﻿
function GetCommandsByIndex(index)
	local coms = {};
	if (index == 27) then
		coms = {15, 16, 17, 18, 19, 48, 49, 50, 51};
	elseif (index == 28) then
		coms = {8, 9, 10, 11, 12, 13, 45};
	elseif (index == 29) then
		coms = {6, 20, 21, 22, 24, 47, 46, 43, 54};
	elseif (index == 30) then
		coms = {1, 2, 3, 4, 58, 52, 25, 44, 60, 64, 62, 63};
	elseif (index == 31) then
		coms = {32, 33, 61, 34, 35, 36, 37, 38, 39, 40, 55, 56, 57, 41};
	end
	return coms;
end

function GetCommandNameByIndex(index)
	if (index == 27) then
		return "机器人攻击操作";
	elseif (index == 28) then
		return "机器人逃跑操作";
	elseif (index == 29) then
		return "其它选项操作";
	elseif (index == 30) then
		return "机器人选项操作";
	elseif (index == 31) then
		return "机器人上线操作";
	end
	return "未知组命令";
end

function ShowCommandGroupBox(groupIndex)
	if(groupIndex < 27 or groupIndex > 31) then
		return nil;
	end
	local frameName = "CommandGroupBox"..tostring(groupIndex);
	if(CanAddToCommandGroupBox(frameName) == false) then
		CloseCommandGroupBoxByName(frameName);
		return 0;
	end
	local coms = GetCommandsByIndex(groupIndex);
	local count = #coms;

	UnBotCloseAllCommandGroupBox();
	local commandBox = CreateFrame("Frame",frameName,UIParent,"CommandGroupBox");
	if (AddToCommandGroupBox(commandBox, frameName) == false) then
		commandBox:Hide();
		commandBox:SetParent(nil);
		return 0;
	end

	commandBox.title = commandBox:CreateFontString(commandBox:GetName().."Title","ARTWORK");
	commandBox.title:SetFont([[Fonts\ZYHei.ttf]],18);
	commandBox.title:SetTextColor(1,0,0,1);
	commandBox.title:SetText(GetCommandNameByIndex(groupIndex));
	commandBox.title:SetPoint("TOP",commandBox,"TOP",0,5);
	commandBox.title:SetShadowColor(0,0,0);
	commandBox.title:SetShadowOffset(1,-1);
	
	local gap = 5;
	local onceHeight = 32 + gap;
	commandBox:SetSize(260, 30 + gap * 4 + (onceHeight * count));
	for i=1, count do
		local height = (gap + 30 + onceHeight * (i - 1)) * (-1);
		local commandBtn = CreateFrame("Button","CommandGroupBtn"..tostring(groupIndex),commandBox,"UnBotCommandGroupBoxButtonTemplate");
		commandBtn:SetPoint("TOPLEFT", commandBox, "TOPLEFT", 20, height);
		commandBtn.groupIndex = 1;
		commandBtn.comIndex = coms[i];
		commandBtn.Icon = commandBtn:CreateTexture("UnBotSubIcon"..tostring(coms[i]),"ARTWORK");--BACKGROUND
		local text = GetIconPathByIndex(UnBotIconFiles[coms[i]]);
		commandBtn.Icon:SetTexture(text);
		commandBtn.Icon:SetAllPoints(commandBtn);
		commandBtn.Icon:Show();
		commandBtn:Show();
		commandBtn:SetPushedTexture([[Interface\BUTTONS\UI-Quickslot-Depress]]);
		commandBtn:SetHighlightTexture([[Interface\Buttons\UI-Common-MouseHilight]],"ADD");

		commandBtn.countLabel = commandBtn:CreateFontString(commandBtn:GetName().."Title","OVERLAY");
		commandBtn.countLabel:SetFont([[Fonts\ZYHei.ttf]],18);
		commandBtn.countLabel:SetTextColor(0,0.8,0,1);
		commandBtn.countLabel:SetHeight(18);
		local btnTitle = UnBotTooltipTitle[coms[i]];
		commandBtn.countLabel:SetText(btnTitle);
		commandBtn.countLabel:SetPoint("LEFT",commandBtn,"RIGHT",10,0);
		commandBtn.countLabel:SetJustifyH("RIGHT");
		commandBtn.countLabel:SetJustifyV("BOTTOM");
		commandBtn.countLabel:SetShadowColor(0.1,0.1,0.1);
		commandBtn.countLabel:SetShadowOffset(1,-1);
	end

	commandBox:Show();

	local closeFrame = CreateFrame("Button","CommandGroupBoxBtn"..tostring(groupIndex),commandBox,"UIPanelCloseButton");
	closeFrame:SetWidth(58);
	closeFrame:SetHeight(58);
	closeFrame:Show();
	closeFrame:SetPoint("TOPRIGHT", commandBox, "TOPRIGHT", 20, 20);
	closeFrame:SetScript("OnClick", function()
		RemoveFromCommandGroupBox(commandBox)
		commandBox:Hide()
		commandBox:SetParent(nil)
	end);

	return commandBox;
end

function UnBotCloseAllCommandGroupBox()
	for i=1, #(PBotFrame.ShowedGroupBox) do
		PBotFrame.ShowedGroupBox[i]:Hide();
		PBotFrame.ShowedGroupBox[i]:SetParent(nil);
	end
	PBotFrame.ShowedGroupBox = {};
end
