﻿
function CommandUnBotSetting(index)
	UnBotHideAllSubFrame();
	UnBotCloseAllBagsFrame();
	UnBotCloseAllCommandGroupBox();
	--OnlineFrame:Hide();
	--NPCFrame:Hide();
	
	if (InspectFrame:IsShown()) then
		DisplayInfomation("InspectFrame_Show "..UnitName(InspectFrame.unit)..", Name "..InspectFrame:GetName());
	end
end

function CommandGroupInviteFriend(index)
	if (not IsPartyLeader() and not IsRaidLeader()) then
		DisplayInfomation("你当前不是队伍领袖。");
		return;
	end

	local selfName = UnitName("player");
	SendChatMessage("groupfriend ", "SAY", nil, nil);
end

function CommandBotAttack(index)
	local targetName = UnitName("target");
	if (targetName == nil or targetName == "") then
		DisplayInfomation("你当前没有选择目标。");
		return;
	end
	if (not IsPartyLeader() and not IsRaidLeader()) then
		DisplayInfomation("你当前不是队伍领袖。");
	end
	
	if (IsShiftKeyDown()) then
		SendChatMessage("@tank attack", "PARTY");
	else
		SendChatMessage("attack", "PARTY");
	end
end

function CommandFriendsInvite(index)
	local num= GetNumFriends();
	if num>0 then
		local partyCount = GetNumPartyMembers();
		local raidCount = GetNumRaidMembers();
		for x=1,num,1 do
			local name,level,className,un2,online,un4 = GetFriendInfo(x);
			if (name ~= nil) then
				local isParty = UnitInParty(name);
				local isRaid = UnitInRaid(name);
				if (isParty == nil and isRaid == nil) then
					if (partyCount == 4 and raidCount == 0) then
						ConvertToRaid();
						return;
					end
					InviteUnit(name);
				end
			end
		end
	else
		DisplayInfomation("你当前没有好友。");
	end
end

function CommandListIcons(index)
	local iconsList = {};
	for i=1, #UnBotCommandIconsPath do iconsList[i] = {[1]=i} end
	CreateIconsByUnBotBagsFrame(0, "UnBotBagsFrameIcon",0,false,iconsList,UnitName("player"),UnitClass("player")," 所有图标展示",nil,nil,GetIconFunc);
end

function CommandInspectFrame(index)
	local targetClass = UnitClass("target");
	local targetName = UnitName("target");
	local isParty = UnitInParty("target");
	local isRaid = UnitInRaid("target");
	if (targetName == nil or targetName == "") then
		DisplayInfomation("你当前没有选择目标。");
		return;
	end
	if (not UnitIsPlayer("target")) then
		DisplayInfomation("需要选择一个玩家机器人作为目标。");
		return;
	end
	if (isParty == nil and isRaid == nil) then
		DisplayInfomation("选择目标不在你的队伍中。");
		return;
	end
	if (not IsPartyLeader() and not IsRaidLeader()) then
		DisplayInfomation("你当前不是队伍领袖。");
		return;
	end
	InspectFrame_Show("target");
end

function CommandCombatStop(index)
	if (not IsPartyLeader() and not IsRaidLeader()) then
		DisplayInfomation("你当前不是队伍领袖。");
		return;
	end

	if (UnitInRaid("player") ~= nil) then
		if (GetNumRaidMembers()>0) then
			for i=1, GetNumRaidMembers(), 1 do
				local name = (UnitName("raid"..i));
				if (name) then
					DisplayInfomation("团队中的 "..name.." 脱离战斗");
					SendChatMessage(UnBotExecuteCommand[index]..name, "PARTY");
				end
			end
		end
	else
		SendChatMessage(UnBotExecuteCommand[index]..UnitName("player"), "PARTY");
		if (GetNumPartyMembers()>0) then
			for i=1, GetNumPartyMembers(), 1 do
				local name = (UnitName("party"..i));
				if (name) then
					DisplayInfomation("小队中的 "..name.." 脱离战斗");
					SendChatMessage(UnBotExecuteCommand[index]..name, "PARTY");
				end
			end
		end
	end
end

function CommandUninvite(index)
	if (not IsPartyLeader() and not IsRaidLeader()) then
		DisplayInfomation("你当前不是队伍领袖。");
		return;
	end
	SendChatMessage("nc +grind", "PARTY");
	SendChatMessage("stay", "PARTY");
	if (UnitInRaid("player") ~= nil) then
		if (GetNumRaidMembers()>0) then
			for i=1, GetNumRaidMembers(), 1 do
				local name = (UnitName("raid"..i));
				if (name and name ~= UnitName("player")) then
					UninviteUnit(name);
				end
			end
		end
	else
		if (GetNumPartyMembers()>0) then
			for i=1, GetNumPartyMembers(), 1 do
				local name = (UnitName("party"..i));
				if (name and name ~= UnitName("player")) then
					UninviteUnit(name);
				end
			end
		end
	end
end

function CommandUnBotItemList(index)
	local targetClass = UnitClass("target");
	local targetName = UnitName("target");
	local isParty = UnitInParty("target");
	local isRaid = UnitInRaid("target");
	if (targetName == nil or targetName == "") then
		DisplayInfomation("你当前没有选择目标。");
		return;
	end
	if (not UnitIsPlayer("target")) then
		DisplayInfomation("需要选择一个玩家机器人作为目标。");
		return;
	end
	if (isParty == nil and isRaid == nil) then
		DisplayInfomation("选择目标不在你的队伍中。");
		return;
	end
	if (not IsPartyLeader() and not IsRaidLeader()) then
		DisplayInfomation("你当前不是队伍领袖。");
		return;
	end
	CreateIconsByUnBotBagsFrame(1, "UnBotItemList"..targetName,1,false,{},targetName,targetClass," 查看道具",FlushItemsToBags,nil,GetItemFunc);
end

function CommandOnlineBot(index)
	local cls = 0;
	if (index == 32) then
		cls = 1;
	elseif (index == 33) then
		cls = 2;
	elseif (index == 61) then
		cls = 6;
	elseif (index == 34) then
		cls = 4;
	elseif (index == 35) then
		cls = 11;
	elseif (index == 36) then
		cls = 3;
	elseif (index == 37) then
		cls = 7;
	elseif (index == 38) then
		cls = 8;
	elseif (index == 39) then
		cls = 9;
	elseif (index == 40) then
		cls = 5;
	else
		return;
	end
	if (IsShiftKeyDown()) then
		SendChatMessage("onlineaccbot "..tostring(cls), "SAY", nil, nil);
	else
		SendChatMessage("onlineselfbot "..tostring(cls), "SAY", nil, nil);
	end
end

function CommandOfflineBot(index)
	SendChatMessage("offlineallbot ", "SAY", nil, nil);
end

function CommandSupperMenu(index)
	SendChatMessage("supermenu ", "SAY", nil, nil);
end

function CommandResetDungeon(index)
	SendChatMessage("resetdungeon ", "SAY", nil, nil);
end

function CommandSaveAndQuit(index)
	SendChatMessage("saveall ", "SAY", nil, nil);
	Quit();
end

function CommandRandomFormation(index)
	if (IsShiftKeyDown()) then
		SendChatMessage("formation random", "PARTY", nil, nil);
	else
		SendChatMessage("@ranged formation random", "PARTY", nil, nil);
	end
end

function CommandPulls(index)
	SendChatMessage("pulls ", "PARTY", nil, nil);
end

function CommandOnlineFriends(index)
	SendChatMessage("onlinefriends ", "SAY", nil, nil);
end

function CommandToggleWarfareAid(index)
	SendChatMessage("warfareaid ", "SAY", nil, nil);
end

function CommandBindingHome(index)
	SendChatMessage("bindinghome ", "SAY", nil, nil);
end

function CommandOnlineArenaTeam2v2(index)
	SendChatMessage("onlinearenateam2 ", "SAY", nil, nil);
end

function CommandOnlineArenaTeam3v3(index)
	SendChatMessage("onlinearenateam3 ", "SAY", nil, nil);
end

function CommandOnlineArenaTeam5v5(index)
	SendChatMessage("onlinearenateam5 ", "SAY", nil, nil);
end

function CommandOnlineGuildMembers(index)
	SendChatMessage("onlineguildmember ", "SAY", nil, nil);
end
