﻿
function GetIntimacyTypeText(intType)
	if (intType == 0) then
		return " 携手同心 ";
	elseif (intType == 1) then
		return " 生死与共 ";
	elseif (intType == 2) then
		return " 相依为命 ";
	else
		return " 亲密度 ";
	end
end

function CombinIntimacyRateText(index, intval, intmax, step, maxstep)
	if (intval >= step * index) then
		return tostring(step).." / "..tostring(step), 1;
	else
		local curval = intval - step * (index-1);
		if(curval < 0) then
			curval = 0;
		end
		local active = 0;
		if (curval >= step) then
			active = 1;
		end
		return tostring(curval).." / "..tostring(step), active;
	end
end

function AnalyzeIntimacyInfo(info)
	if (info == nil) then
		return;
	end
	-- IntimacyInfoState:guid:012:value:max:id1:id2:id3:id4:id5
	-- /w admin IntimacyInfoState:1:2:700:2000:14:17:25:43:45
	local i1,i2 = string.find(info,"IntimacyInfoState:");
	--DisplayInfomation(tostring(i2));
	if (i1 == nil or i2 == nil or i2 ~= 18) then
		return;
	end
	local splitSubs = UnBotSplit(info, ":");
	if (#splitSubs ~= 10) then
		return;
	end

	local infoState = {};
	for i=2, #splitSubs do
		local sunNum = tonumber(splitSubs[i]);
		if(sunNum == nil) then
			return;
		else
			table.insert(infoState, sunNum);
			--DisplayInfomation(tostring(sunNum));
		end
	end
	if (#infoState ~= 9) then
		return;
	end
	local spellCount = 0;
	if(infoState[5] > 0) then
		spellCount = spellCount + 1;
		if(infoState[6] > 0) then
			spellCount = spellCount + 1;
			if(infoState[7] > 0) then
				spellCount = spellCount + 1;
				if(infoState[8] > 0) then
					spellCount = spellCount + 1;
					if(infoState[9] > 0) then
						spellCount = spellCount + 1;
					end
				end
			end
		end
	end
	return infoState[1],infoState[2],infoState[3],infoState[4],infoState[5],infoState[6],infoState[7],infoState[8],infoState[9],spellCount;
end

function ShowIntimacyInfoBox(name, info)
	local intGuid, intType, intValue, intMax, intId1, intId2, intId3, intId4, intId5, spellCount = AnalyzeIntimacyInfo(info);
	if(name == nil or intGuid == 0 or intGuid == nil) then
		return;
	end
	local spellIDs = {intId1, intId2, intId3, intId4, intId5};
	local frameName = "IntimacyInfoBox";

	UnBotCloseIntimacyInfoBox();
	local commandBox = CreateFrame("Frame",frameName,UIParent,"IntimacyInfoTemplate");

	commandBox.title = commandBox:CreateFontString(commandBox:GetName().."Title","ARTWORK");
	commandBox.title:SetFont([[Fonts\ZYHei.ttf]],18);
	commandBox.title:SetTextColor(0,1,0,1);
	commandBox.title:SetText(GetIntimacyTypeText(intType)..tostring(name));
	commandBox.title:SetPoint("TOP",commandBox,"TOP",0,5);
	commandBox.title:SetShadowColor(0,0,0);
	commandBox.title:SetShadowOffset(1,-1);
	
	local gap = 5;
	local onceHeight = 32 + gap;
	commandBox:SetSize(260, 30 + gap * 4 + (onceHeight * spellCount));
	for i=1, #spellIDs do
		local spellName,rankLV,texture,costMana,un3,costType,castTime,un6,distance = GetSpellInfo(spellIDs[i]);
		if (spellName == nil) then
			break;
		end
		local height = (gap + 30 + onceHeight * (i - 1)) * (-1);
		local commandBtn = CreateFrame("Button","IntimacyInfoBtn"..tostring(i),commandBox,"UnBotIntimacySpellTemplate");
		local spellText, active = CombinIntimacyRateText(i, intValue, intMax, 400, spellCount);
		commandBtn.spell = spellIDs[i];
		commandBtn.isActive = active;
		commandBtn:SetPoint("TOPLEFT", commandBox, "TOPLEFT", 20, height);
		commandBtn.Icon = commandBtn:CreateTexture("UnBotIntimacySpellSubIcon"..tostring(i),"ARTWORK");--BACKGROUND
		commandBtn.Icon:SetTexture(texture);
		commandBtn.Icon:SetAllPoints(commandBtn);
		commandBtn.Icon:Show();
		commandBtn:Show();
		commandBtn:SetPushedTexture([[Interface\BUTTONS\UI-Quickslot-Depress]]);
		commandBtn:SetHighlightTexture([[Interface\Buttons\UI-Common-MouseHilight]],"ADD");

		commandBtn.countLabel = commandBtn:CreateFontString(commandBtn:GetName().."Title","OVERLAY");
		commandBtn.countLabel:SetFont([[Fonts\ZYHei.ttf]],18);
		if (active >= 1) then
			commandBtn.countLabel:SetTextColor(0,0,1,1);
		else
			commandBtn.countLabel:SetTextColor(1,0,0,1);
		end
		commandBtn.countLabel:SetHeight(18);
		commandBtn.countLabel:SetText(spellName.."  "..spellText);
		commandBtn.countLabel:SetPoint("LEFT",commandBtn,"RIGHT",10,0);
		commandBtn.countLabel:SetJustifyH("RIGHT");
		commandBtn.countLabel:SetJustifyV("BOTTOM");
		commandBtn.countLabel:SetShadowColor(0.1,0.1,0.1);
		commandBtn.countLabel:SetShadowOffset(1,-1);
	end

	PBotFrame.IntimacyInfo = commandBox;
	commandBox:Show();

	local closeFrame = CreateFrame("Button","IntimacyInfoBoxCloseBtn",commandBox,"UIPanelCloseButton");
	closeFrame:SetWidth(58);
	closeFrame:SetHeight(58);
	closeFrame:Show();
	closeFrame:SetPoint("TOPRIGHT", commandBox, "TOPRIGHT", 20, 20);
	closeFrame:SetScript("OnClick", function()
		UnBotCloseIntimacyInfoBox()
	end);

	return commandBox;
end

function UnBotIntimacyInfoTips(newFrame, spellID, active)
	local spellLink = GetSpellLink(spellID);
	if(spellLink == nil) then
		GameTooltip:Hide();
		return;
	end
	GameTooltip:SetOwner(newFrame, "ANCHOR_TOPRIGHT");
	GameTooltip:SetHyperlink(spellLink);
	
	GameTooltip:AddLine(" ",1,1,1,1);
	if(active >= 1) then
		GameTooltip:AddDoubleLine("激活状态","已激活",0,0,0.8,0,0.8,0);
	else
		GameTooltip:AddDoubleLine("激活状态","未激活",0.8,0,0,0.8,0,0);
	end
	GameTooltip:Show();
end

function UnBotCloseIntimacyInfoBox()
	if (PBotFrame.IntimacyInfo ~= nil) then
		PBotFrame.IntimacyInfo:Hide();
		PBotFrame.IntimacyInfo:SetParent(nil);
		PBotFrame.IntimacyInfo = nil;
	end
end
